#!/usr/bin/ruby
require 'tempfile'
require 'cgi'
require 'digest/md5'


def saveSelectedItemByPlaylist cgi, f, musicWebRoot
	user = cgi['loginUser'].to_s
	md5 = cgi['loginUserMD5'].to_s
	type = cgi['fileType'].to_s
	regexp = Regexp.new("[^#{URI::PATTERN::ALNUM}\.\/]")
	f.write( "#EXTM3U\n" )
	cgi.each{|key,value|
		if /file[0-9]+@/ =~ key
			f.write "#EXTINF:-1,#{value[0]}\n"
			addr = musicWebRoot.clone
			addr.sub! "${type}", type
			addr.sub! "${file}", URI.escape(value[0], regexp)
			addr.sub! "${user}", user
			addr.sub! "${md5}",  Digest::MD5.hexdigest(md5 + ":" + type + ":" + value[0])
			f.write addr + "\n"
		end
	}
end

def createMusicDataFromSelectedItem cgi, playList
	cgi.each{|key,value|
		if /file[0-9]+@/ =~ key
			playList.push value[0]
		end
	}
end
	
begin
	require 'conf/millefee.conf.rb'
	require $MUSIC_SERVER_RHTML_ROOT + '/lib/libCommon.rb'
	require $MUSIC_SERVER_RHTML_ROOT + '/lib/libAudio.rb'
	
	$CGI = CGI.new
	$CONF = loadConfig $MUSIC_SERVER_RHTML_ROOT + '/conf/password.conf.rhtml'

	ssl = 0
	user = $CGI.params['loginUser'].to_s
	md5 = $CONF[user]
	raise if md5 != $CGI.params['loginUserMD5'].to_s

	if $CGI.params['playSelected'].size > 0
		url = ( ( ssl == '1' ) ? "https://" : "http://" ) + ENV['HTTP_HOST'] + File.dirname(ENV['SCRIPT_NAME']) + "/mediadlfilter.rb"
		url += "?type=${type}&file=${file}&user=${user}&md5=${md5}"

		playlist = Tempfile.open 'playlist'
		saveSelectedItemByPlaylist $CGI.params, playlist, url
		playlist.pos = 0
		param = {
			'status' => 'OK',
			'type'   => 'audio/playlist',
			'length' => playlist.stat.size,
			'Content-Disposition' => "attachment; filename=\"playlist.m3u\""
		}
		print $CGI.header(param)
		print playlist.read
	elsif $CGI.params['savePlayList'].size > 0
		playList = MusicPlayList.new nil
		playList.setTitle "MyPlayList" # $CGI.params['title'].to_s
		playList.setDefaultPlayStyle $CGI.params['defaultPlayStyle']
		createMusicDataFromSelectedItem $CGI.params, playList
		playList.saveAs $MUSIC_SERVER_RHTML_ROOT + "/data/audio/playlist/myplaylist.playlist"
		param = {
			'status' => '204 No Content',
		}
		print $CGI.header(param)
	end
rescue Exception => e
	begin
		displayHtmlHeader
		displayExceptionMessage e
	rescue
		print "Content-type: text/html\n\n"
	end
	exit
end
