var rightPanelMusicCategoryMoniter = null;

function doLayoutAudioBrowseView( )
{
	var height = document.documentElement.clientHeight;
	var width = document.documentElement.clientWidth;
	if( width <= 0 )
		width = document.body.clientWidth;
	if( height <= 0 )
		height = document.body.clientHeight;
	if( width < 32 )
		width = 32;
	if( height < 32 )
		height = 32;

	var musicToolMenu = document.getElementById( "MusicToolMenu" );
	var categoryView = document.getElementById( "MusicCategoryTree" );
	if( musicToolMenu != null )
	{
		musicToolMenu.style.position = "relative";
		musicToolMenu.style.left = "0px";
		musicToolMenu.style.top = "0px";
		musicToolMenu.style.height = "48px";
		musicToolMenu.style.width = "100%";
		musicToolMenu.style.overflow = "auto";
	}

	if( categoryView != null )
	{
		categoryView.style.position = "relative";
		categoryView.style.left = "0px";
		categoryView.style.top = "0px";
		categoryView.style.height = ( ( height - 96 > 0 ) ? height - 96 : 1 ) + "px";
		categoryView.style.width = "100%";
		categoryView.style.overflow = "auto";
	}
}

function treeExpand(menu_class, menu_id) 
{
	var target = document.getElementById("child@" + menu_id);
	if (target.style.display == "block")
		target.style.display="none";
	else 
	{
		var sib=target.parentNode.childNodes;
		for (var i=0; i < sib.length; i++)
			if (sib[i].className == menu_class) 
				sib[i].style.display="none";
		target.style.display="block";
	}
}

function checkAllChild(value )
{
	var target = 
		document.getElementsByName( "checkbox@" + value );
	var mode = 
		target[0].checked;
	var dest =
		document.getElementById( "child@" + value );
	dest = dest.getElementsByTagName( "input" );	
	for( var i = 0; i < dest.length; i ++ )
	{
		dest[i].checked = mode;
	}
}

function updateNowPlayingMusicCallback( cgi, param )
{
	var view = document.getElementById( "NowPlayingMusicMonitor" );
	if( view == null )
	{
		if(rightPanelMusicCategoryMoniter != null)
		{
			rightPanelMusicCategoryMoniter.abort( );
			rightPanelMusicCategoryMoniter = null;
		}
		return;
	}
	try
	{
		var rightPanel = null;
		if ( rightPanelMusicCategoryMoniter.readyState == 4 && rightPanelMusicCategoryMoniter.status == 200)
		{
			var response = rightPanelMusicCategoryMoniter.responseText;
			var elems = response.split( "\n" );
			var text = "";
			if( view != null )
			{
				for( var i = elems.length-1; i >= 0; i -- )
				{
					if( elems[i] != "*" )
					{
						text = elems[i];
						break;
					}
				}
				try
				{
					view.innerText = text;
					view.textContent = text;
				}
				catch( e )
				{
				}
			}
		}
		if( rightPanelMusicCategoryMoniter.readyState == 4 )
		{
			rightPanelMusicCategoryMoniter = null;
			updateNowPlayingMusic( cgi, param );
		}
	}
	catch(e)
	{
		if( rightPanelMusicCategoryMoniter != null &&
		   rightPanelMusicCategoryMoniter.readyState==4)
		{
			rightPanelMusicCategoryMoniter = null;
			updateNowPlayingMusic( cgi, param );
		}
	}
}

function updateNowPlayingMusic( cgi, param )
{
	try
	{
		var view = document.getElementById( "NowPlayingMusicMonitor" );
		if( view != null )
		{
			var currentPlay = view.innerText;
			if ( !currentPlay || typeof currentPlay == 'undefined') 
				currentPlay = view.textContent;
			if( rightPanelMusicCategoryMoniter != null )
				rightPanelMusicCategoryMoniter.abort( );
			rightPanelMusicCategoryMoniter = createXMLHttpRequestObject( );
			if (rightPanelMusicCategoryMoniter)
			{
				var func = function(){ updateNowPlayingMusicCallback( cgi, param ) };
				rightPanelMusicCategoryMoniter.onreadystatechange = func;
				rightPanelMusicCategoryMoniter.open("POST", cgi, true );
				rightPanelMusicCategoryMoniter.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
				rightPanelMusicCategoryMoniter.send( param.replace( "*current*", currentPlay ) );
			}
		}
	}
	catch( e )
	{
	}
}

function doLayoutAudioPlayListView( )
{
	var height = document.documentElement.clientHeight;
	var width = document.documentElement.clientWidth;
	if( width <= 0 )
		width = document.body.clientWidth;
	if( height <= 0 )
		height = document.body.clientHeight;
	if( width < 32 )
		width = 32;
	if( height < 32 )
		height = 32;
	var musicPlayListFile = document.getElementById( "MusicPlayListFileView" );
	var musicPlayListItem = document.getElementById( "MusicPlayListItemView" );
	if( musicPlayListFile != null )
	{
		musicPlayListFile.style.position = "relative";
		musicPlayListFile.style.left = "0px";
		musicPlayListFile.style.top = "0px";
		musicPlayListFile.style.height = "48px";
		musicPlayListFile.style.width = "100%";
		musicPlayListFile.style.overflow = "auto";
	}

	if( musicPlayListItem != null )
	{
		musicPlayListItem.style.position = "relative";
		musicPlayListItem.style.left = "0px";
		musicPlayListItem.style.top = "0px";
		musicPlayListItem.style.height = ( ( height - 96 > 0 ) ? height - 96 : 1 ) + "px";
		musicPlayListItem.style.width = "100%";
		musicPlayListItem.style.overflow = "auto";
	}
}

function updateCurrentPlayListCallback( xmlhttpCurrentPlayList )
{
	try
	{
		if ( xmlhttpCurrentPlayList.readyState == 4 && xmlhttpCurrentPlayList.status == 200) 
		{
			var response = xmlhttpCurrentPlayList.responseText;
			var view = document.getElementById( "MusicPlayListItemView" );
			if( view != null )
				view.innerHTML = response;
		}
	}
	catch( e )
	{
	}
}

function updateCurrentPlayList( cgi, param )
{
	try
	{
		var xmlhttpCurrentPlayList = createXMLHttpRequestObject( );
		if (xmlhttpCurrentPlayList)
		{
			var func = function(){ updateCurrentPlayListCallback( xmlhttpCurrentPlayList ) };
			xmlhttpCurrentPlayList.onreadystatechange = func;
			xmlhttpCurrentPlayList.open("POST", cgi, true );
			xmlhttpCurrentPlayList.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
			xmlhttpCurrentPlayList.send( param );
		}
	}
	catch( e )
	{
	}
}

