var layoutRightPanelMethod = null;
	
function doLayoutLoginWindow( )
{
	var height = document.documentElement.clientHeight;
	var width = document.documentElement.clientWidth;
	if( height <= 0 )
		height = document.body.clientHeight;
	if( width <= 0 )
		width = document.body.clientWidth;

	if( width < 20 )
		width = 20;
	if( height < 20 )
		height = 20;
	var loginView = document.getElementById( "login" );
	if( loginView != null )
	{
		loginView.style.width = ( width - 56 ) + "px";
		loginView.style.height = ( height - 56 ) + "px";
		loginView.style.overflow="auto";
	}

	var loginInput = document.getElementById( "loginInput" );
	if( loginInput != null )
	{
		loginInput.style.left = ( width - loginInput.offsetWidth ) / 2 + "px";
		loginInput.style.top = ( height - loginInput.offsetHeight )  / 3 + "px";
	}
}

function loadLoginWindow( )
{
	window.onload = doLayoutLoginWindow;
	window.onresize = doLayoutLoginWindow;
	doLayoutMainWindow( );
}

function doLayoutMainWindow( )
{
	var height = document.documentElement.clientHeight;
	var width = document.documentElement.clientWidth;
	if( width <= 0 )
		width = document.body.clientWidth;
	if( height <= 0 )
		height = document.body.clientHeight;
	if( width < 32 )
		width = 32;
	if( height < 48 )
		height = 48;

	var topPanel = document.getElementById( "topLevelView" );
	var leftPanel = document.getElementById( "LeftSideView" );
	var rightPanel = document.getElementById( "RightSideView" );
	var copyright = document.getElementById( "copyrightView" );

	if( topPanel == null || leftPanel == null || rightPanel == null || copyright == null )
		return;
	topPanel.style.position = "relative";
	topPanel.style.left = 0;
	topPanel.style.top = 0;
	topPanel.style.width = ( width - 32 ) + "px";
	topPanel.style.height = ( height - 48 ) + "px";
	leftPanel.style.position = "absolute";
	leftPanel.style.left = "0px";
	leftPanel.style.top = "0px";
	leftPanel.style.width = 120 + "px";
	leftPanel.style.height = topPanel.offsetHeight + "px";
	
	rightPanel.style.position = "absolute";
	rightPanel.style.left = leftPanel.offsetWidth + "px";
	rightPanel.style.top = "0px";
	rightPanel.style.width = ( topPanel.offsetWidth - 120 ) + "px";
	rightPanel.style.height = topPanel.offsetHeight + "px";
	
	doLayoutLeftPanel( );
	if( layoutRightPanelMethod != null )
		layoutRightPanelMethod( );
	
	if( copyright != null )
	{
		copyright.style.top = "0px";
		copyright.style.height = "32px";
	}
}

function doLayoutLeftPanel( )
{
	var height = document.documentElement.clientHeight;
	var width = document.documentElement.clientWidth;
	if( width <= 0 )
		width = document.body.clientWidth;
	if( height <= 0 )
		height = document.body.clientHeight;
	if( width < 32 )
		width = 32;
	if( height < 32 )
		height = 32;

	var accountView = document.getElementById( "UserAccountView" );
	var modeSelectorView = document.getElementById( "ModeSelectorView" );
	accountView.style.position = "relative";
	accountView.style.left = "0px";
	accountView.style.top = "0px";
	accountView.style.height = "32px";
	accountView.style.width = "100%"

	modeSelectorView.style.position = "relative";
	modeSelectorView.style.left = "0px";
	modeSelectorView.style.top = "0px";
	modeSelectorView.style.width = "100%";
 	modeSelectorView.style.height = ( ( height - 72 > 0 ) ? height - 72 : 1 ) + "px";
}

function loadNowLoadingView( )
{
	var rightPanel = document.getElementById( "mainRequestContainer" );
	var loading = document.getElementById( "NowLoading" );
	if( ( rightPanel != null ) && ( loading != null ) )
	{
		var widthParent = rightPanel.offsetWidth;
		var heightParent =  rightPanel.offsetHeight;
		var widthChild =  loading.offsetWidth;
		var heightChild =  loading.offsetHeight;
		loading.style.left = ( ( widthParent - widthChild ) / 2 ) + "px";
		loading.style.top = ( ( heightParent - heightChild ) / 2 ) + "px";
	}
}

function executeLoadingScreen( )
{
	var progress = 
		document.getElementById( "NowLoading" );
	var status = 
		document.getElementById( "LoadingCurrentStatus" );
	if( ( progress != null ) && ( status != null ) )
	{
		var now = status.textContent;
		if( now == "" )
		{
			status.textContent = "0";
			document.getElementById( "LoadingProgress" ).textContent = "|";
		}
		else if( now == "0" )
		{
			status.textContent = "1";
			document.getElementById( "LoadingProgress" ).textContent = "/";
		}
		else if( now == "1" )
		{
			status.textContent = "2";
			document.getElementById( "LoadingProgress" ).textContent = "-";
		}
		else if( now == "2" )
		{
			status.textContent = "3";
			document.getElementById( "LoadingProgress" ).textContent = "\\";
		}
		else if( now == "3" )
		{
			status.textContent = "4";
			document.getElementById( "LoadingProgress" ).textContent = "|";
		}
		else if( now == "4" )
		{
			status.textContent = "5";
			document.getElementById( "LoadingProgress" ).textContent = "/";
		}
		else if( now == "5" )
		{
			status.textContent = "6";
			document.getElementById( "LoadingProgress" ).textContent = "-";
		}
		else if( now == "6" )
		{
			status.textContent = "7";
			document.getElementById( "LoadingProgress" ).textContent = "\\";
		}
		else if( now == "7" )
		{
			status.textContent = "0";
			document.getElementById( "LoadingProgress" ).textContent = "|";
		}
		setTimeout(executeLoadingScreen, 150);
	}
}

function unloadRightPanelComponents( )
{
	var rightPanelForm = document.getElementById( "mainRequestForm" );
	var rightPanelContainer = document.getElementById( "mainRequestContainer" );
	if ( rightPanelForm != null )
	{
		if( rightPanelContainer != null )
			rightPanelForm.removeChild( rightPanelContainer );
		var newElement = document.createElement('div');
		rightPanelForm.appendChild( newElement );
		newElement.id = "mainRequestContainer";
	}
}

function doLayoutModalDialog( )
{
	var dialogRoot = document.getElementById( "dialogRoot" );
	var dialogElement = document.getElementById( "frontDialog" );
	var offsetWidth = dialogElement.offsetWidth;
	var offsetHeight = dialogElement.offsetHeight;
	
	var rootWidth = dialogRoot.offsetWidth;
	var rootHeight = dialogRoot.offsetHeight;
	var dialogWidth = dialogElement.offsetWidth;
	var dialogHeight = dialogElement.offsetHeight;
	
	dialogElement.style.left = ( rootWidth - dialogWidth ) / 2 + "px";
	dialogElement.style.top = ( rootHeight - dialogHeight ) / 2 + "px";
}

function showDialogCallBack( xmlhttpDialog )
{
	if ( xmlhttpDialog.readyState == 4 && xmlhttpDialog.status == 200) 
	{
		var topLevelView = document.getElementById( "topLevelView" );
		var leftView = document.getElementById( "LeftSideView" );
		var rightView = document.getElementById( "RightSideView" );
		leftView.style.display = "none";
		rightView.style.display = "none";
		var dialogRoot = document.createElement("div");
		dialogRoot.id = "dialogRoot";
		dialogRoot.style.width = "100%";
		dialogRoot.style.height = "100%";
		dialogRoot.innerHTML = xmlhttpDialog.responseText;
		topLevelView.appendChild( dialogRoot );
		doLayoutModalDialog( );
	}
}

function showDialog( cgi, rhtml, title, message, sizeButton)
{
	var xmlhttpDialog = createXMLHttpRequestObject( );
	if (xmlhttpDialog)
	{
		var param = 
			"rhtml=" + rhtml + "&title=" + title + "&message=" + message;
		var func = function(){ showDialogCallBack( xmlhttpDialog ) };
		xmlhttpDialog.onreadystatechange = func;
		xmlhttpDialog.open("POST", cgi, true );
		xmlhttpDialog.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		xmlhttpDialog.send( param );
	}
}
